diff --git a/eos/private/pc_eos.f90 b/eos/private/pc_eos.f90
index 73031183..f9641a13 100644
--- a/eos/private/pc_eos.f90
+++ b/eos/private/pc_eos.f90
@@ -1826,317 +1339,206 @@
 ! Input: RS - electron density parameter =electron-sphere radius in a.u.
 !        GAME - electron Coulomb coupling parameter
 ! Output: FXC - excess free energy of e-liquid per kT per one electron
-!             according to Tanaka & Ichimaru 85-87 and Ichimaru 93
-!         UXC - internal energy contr.[per 1 electron, kT]
+!             according to Tanaka & Ichimaru 85-87 and Ichimaru 93 FXC,
+!         UXC - free and internal energy contr.[per 1 electron, kT]
 !         PXC - pressure contribution divided by (n_e kT)
 !         CVXC - heat capacity divided by N_e k
 !         SXC - entropy divided by N_e k
 !         PDTXC,PDRXC = PXC + d ln PXC / d ln(T,\rho)
-      use pc_support
-      type(auto_diff_real_2var_order1), intent(in) :: RS, GAME
-      type(auto_diff_real_2var_order1), intent(out) :: FXC,UXC,PXC,CVXC,SXC,PDTXC,PDRXC
-
-      type(auto_diff_real_2var_order1) :: THETA, SQTH, THETA2, THETA3, THETA4, EXP1TH
-      type(auto_diff_real_2var_order1) :: CHT1, SHT1, CHT2, SHT2
-      type(auto_diff_real_2var_order1) :: T1, T2, T1DH, T1DHH, T2DH, T2DHH
-      type(auto_diff_real_2var_order1) :: A0, A0DH, A0DHH, A1, A1DH, A1DHH, A, AH, ADH, ADHH
-      type(auto_diff_real_2var_order1) :: B0, B0DH, B0DHH, B1, B1DH, B1DHH, B, BH, BDH, BDHH
-      type(auto_diff_real_2var_order1) :: C, CDH, CDHH, C3, C3DH, C3DHH
-      type(auto_diff_real_2var_order1) :: D0, D0DH, D0DHH, D1, D1DH, D1DHH, D, DH, DDH, DDHH
-      type(auto_diff_real_2var_order1) :: E0, E0DH, E0DHH, E1, E1DH, E1DHH, E, EH, EDH, EDHH
-      type(auto_diff_real_2var_order1) :: DISCR, DIDH, DIDHH
-      type(auto_diff_real_2var_order1) :: S1, S1H, S1DH, S1DHH, S1DG, S1DHG
-      type(auto_diff_real_2var_order1) :: B2, B2DH, B2DHH, SQGE, B3, B3DH, B3DHH
-      type(auto_diff_real_2var_order1) :: S2, S2H, S2DH, S2DHH, S2DG, S2DGG, S2DHG
-      type(auto_diff_real_2var_order1) :: R3, R3H, R3DH, R3DHH, R3DG, R3DGG, R3DHG
-      type(auto_diff_real_2var_order1) :: S3, S3DH, S3DHH, S3DG, S3DGG, S3DHG
-      type(auto_diff_real_2var_order1) :: B4, B4DH, B4DHH
-      type(auto_diff_real_2var_order1) :: C4, C4DH, C4DHH, C4DG, C4DGG, C4DHG
-      type(auto_diff_real_2var_order1) :: S4A, S4AH, S4ADH, S4ADHH, S4ADG, S4ADGG, S4ADHG
-      type(auto_diff_real_2var_order1) :: S4B, S4BDH, S4BDHH, UP1, DN1, UP2, DN2
-      type(auto_diff_real_2var_order1) :: S4C, S4CDH, S4CDHH, S4CDG, S4CDGG, S4CDHG
-      type(auto_diff_real_2var_order1) :: S4, S4DH, S4DHH, S4DG, S4DGG, S4DHG
-      type(auto_diff_real_2var_order1) :: FXCDH, FXCDHH, FXCDG, FXCDGG, FXCDHG
-      type(auto_diff_real_2var_order1) :: PDLH, PDLG
-
-      real(dp) :: &
-         xFXC, dFXC_dlnRS, dFXC_dlnGAME, &
-         xUXC, dUXC_dlnRS, dUXC_dlnGAME, &
-         xPXC, dPXC_dlnRS, dPXC_dlnGAME, &
-         xCVXC, dCVXC_dlnRS, dCVXC_dlnGAME, &
-         xSXC, dSXC_dlnRS, dSXC_dlnGAME, &
-         xPDTXC, dPDTXC_dlnRS, dPDTXC_dlnGAME, &
-         xPDRXC, dPDRXC_dlnRS, dPDRXC_dlnGAME
-      real(dp) :: dlnRs_dT, dlnRs_dRho, dlnGAME_dT, dlnGAME_dRho
-      integer :: ierr
-      logical :: skip
-      logical, parameter :: use_EXCOR7_table = .true.
-      logical, parameter :: debug_EXCOR7_table = .false.
-
-      if (use_EXCOR7_table .or. debug_EXCOR7_table) then
-         ierr = 0
-         call get_EXCOR7(RS%val, GAME%val, &
-            xFXC, dFXC_dlnRS, dFXC_dlnGAME, &
-            xUXC, dUXC_dlnRS, dUXC_dlnGAME, &
-            xPXC, dPXC_dlnRS, dPXC_dlnGAME, &
-            xCVXC, dCVXC_dlnRS, dCVXC_dlnGAME, &
-            xSXC, dSXC_dlnRS, dSXC_dlnGAME, &
-            xPDTXC, dPDTXC_dlnRS, dPDTXC_dlnGAME, &
-            xPDRXC, dPDRXC_dlnRS, dPDRXC_dlnGAME, skip, ierr)
-         if (ierr /= 0) return
-      else
-         skip = .true.
-      endif
-
-      if (.not. use_EXCOR7_table .or. debug_EXCOR7_table .or. skip) then
+      real(dp), intent(in) :: RS, GAME
+      real(dp), intent(out) :: FXC,UXC,PXC,CVXC,SXC,PDTXC,PDRXC
+
+      real(dp) :: THETA, SQTH, THETA2, THETA3, THETA4, EXP1TH
+      real(dp) :: CHT1, SHT1, CHT2, SHT2
+      real(dp) :: T1, T2, T1DH, T1DHH, T2DH, T2DHH
+      real(dp) :: A0, A0DH, A0DHH, A1, A1DH, A1DHH, A, AH, ADH, ADHH
+      real(dp) :: B0, B0DH, B0DHH, B1, B1DH, B1DHH, B, BH, BDH, BDHH
+      real(dp) :: C, CDH, CDHH, C3, C3DH, C3DHH
+      real(dp) :: D0, D0DH, D0DHH, D1, D1DH, D1DHH, D, DH, DDH, DDHH
+      real(dp) :: E0, E0DH, E0DHH, E1, E1DH, E1DHH, E, EH, EDH, EDHH
+      real(dp) :: DISCR, DIDH, DIDHH
+      real(dp) :: S1, S1H, S1DH, S1DHH, S1DG, S1DHG
+      real(dp) :: B2, B2DH, B2DHH, SQGE, B3, B3DH, B3DHH
+      real(dp) :: S2, S2H, S2DH, S2DHH, S2DG, S2DGG, S2DHG
+      real(dp) :: R3, R3H, R3DH, R3DHH, R3DG, R3DGG, R3DHG
+      real(dp) :: S3, S3DH, S3DHH, S3DG, S3DGG, S3DHG
+      real(dp) :: B4, B4DH, B4DHH
+      real(dp) :: C4, C4DH, C4DHH, C4DG, C4DGG, C4DHG
+      real(dp) :: S4A, S4AH, S4ADH, S4ADHH, S4ADG, S4ADGG, S4ADHG
+      real(dp) :: S4B, S4BDH, S4BDHH, UP1, DN1, UP2, DN2
+      real(dp) :: S4C, S4CDH, S4CDHH, S4CDG, S4CDGG, S4CDHG
+      real(dp) :: S4, S4DH, S4DHH, S4DG, S4DGG, S4DHG
+      real(dp) :: FXCDH, FXCDHH, FXCDG, FXCDGG, FXCDHG
+      real(dp) :: PDLH, PDLG
       
-         THETA=0.543d0*RS/GAME ! non-relativistic degeneracy parameter
-         SQTH=sqrt(THETA)
-         THETA2=THETA*THETA
-         THETA3=THETA2*THETA
-         THETA4=THETA3*THETA
-         if (THETA.gt..007d0) then
-            CHT1=cosh(1.d0/THETA)
-            SHT1=sinh(1.d0/THETA)
-            CHT2=cosh(1.d0/SQTH)
-            SHT2=sinh(1.d0/SQTH)
-            T1=SHT1/CHT1 ! dtanh(1.d0/THETA)
-            T2=SHT2/CHT2 ! dtanh(1./sqrt(THETA))
-            T1DH=-1.d0/((THETA*CHT1)*(THETA*CHT1)) ! d T1 / d\theta
-            T1DHH=2.d0/pow3(THETA*CHT1)*(CHT1-SHT1/THETA)
-            T2DH=-0.5d0*SQTH/((THETA*CHT2)*(THETA*CHT2))
-            T2DHH=(0.75d0*SQTH*CHT2-0.5d0*SHT2)/pow3(THETA*CHT2)
-         else
-            T1=1.d0
-            T2=1.d0
-            T1DH=0.d0
-            T2DH=0.d0
-            T1DHH=0.d0
-            T2DHH=0.d0
-         endif
-         A0=0.75d0+3.04363d0*THETA2-0.09227d0*THETA3+1.7035d0*THETA4
-         A0DH=6.08726d0*THETA-0.27681d0*THETA2+6.814d0*THETA3
-         A0DHH=6.08726d0-0.55362d0*THETA+20.442d0*THETA2
-         A1=1d0+8.31051d0*THETA2+5.1105d0*THETA4
-         A1DH=16.62102d0*THETA+20.442d0*THETA3
-         A1DHH=16.62102d0+61.326d0*THETA2
-         A=0.610887d0*A0/A1*T1 ! HF fit of Perrot and Dharma-wardana
-         AH=A0DH/A0-A1DH/A1+T1DH/T1
-         ADH=A*AH
-         ADHH=ADH*AH+A*(A0DHH/A0-pow2(A0DH/A0)-A1DHH/A1+pow2(A1DH/A1) &
-            + T1DHH/T1-pow2(T1DH/T1))
-         B0=0.341308d0+12.070873d0*THETA2+1.148889d0*THETA4
-         B0DH=24.141746d0*THETA+4.595556d0*THETA3
-         B0DHH=24.141746d0+13.786668d0*THETA2
-         B1=1d0+10.495346d0*THETA2+1.326623d0*THETA4
-         B1DH=20.990692d0*THETA+5.306492d0*THETA3
-         B1DHH=20.990692d0+15.919476d0*THETA2
-         B=SQTH*T2*B0/B1
-         BH=0.5d0/THETA+T2DH/T2+B0DH/B0-B1DH/B1
-         BDH=B*BH
-         BDHH=BDH*BH+B*(-0.5d0/THETA2+T2DHH/T2-pow2(T2DH/T2) &
-            + B0DHH/B0-pow2(B0DH/B0)-B1DHH/B1+pow2(B1DH/B1))
-         D0=0.614925d0+16.996055d0*THETA2+1.489056d0*THETA4
-         D0DH=33.99211d0*THETA+5.956224d0*THETA3
-         D0DHH=33.99211d0+17.868672d0*THETA2
-         D1=1d0+10.10935d0*THETA2+1.22184d0*THETA4
-         D1DH=20.2187d0*THETA+4.88736d0*THETA3
-         D1DHH=20.2187d0+14.66208d0*THETA2
-         D=SQTH*T2*D0/D1
-         DH=0.5d0/THETA+T2DH/T2+D0DH/D0-D1DH/D1
-         DDH=D*DH
-         DDHH=DDH*DH+D*(-0.5d0/THETA2+T2DHH/T2-pow2(T2DH/T2) &
-            + D0DHH/D0-pow2(D0DH/D0)-D1DHH/D1+pow2(D1DH/D1))
-         E0=0.539409d0+2.522206d0*THETA2+0.178484d0*THETA4
-         E0DH=5.044412d0*THETA+0.713936d0*THETA3
-         E0DHH=5.044412d0+2.141808d0*THETA2
-         E1=1d0+2.555501d0*THETA2+0.146319d0*THETA4
-         E1DH=5.111002d0*THETA+0.585276d0*THETA3
-         E1DHH=5.111002d0+1.755828d0*THETA2
-         E=THETA*T1*E0/E1
-         EH=1.d0/THETA+T1DH/T1+E0DH/E0-E1DH/E1
-         EDH=E*EH
-         EDHH=EDH*EH+E*(T1DHH/T1-pow2(T1DH/T1)+E0DHH/E0-pow2(E0DH/E0) &
-            - E1DHH/E1+pow2(E1DH/E1)-1.0d0/THETA2)
-         EXP1TH=exp(-1.d0/THETA)
-         C=(0.872496d0+0.025248d0*EXP1TH)*E
-         CDH=0.025248d0*EXP1TH/THETA2*E+C*EDH/E
-         CDHH=0.025248d0*EXP1TH/THETA2*(EDH+(1.0d0-2.0d0*THETA)/THETA2*E) &
-            + CDH*EDH/E+C*EDHH/E-C*pow2(EDH/E)
-         DISCR=SQRT(4.0d0*E-D*D)
-         DIDH=0.5d0/DISCR*(4.0d0*EDH-2.0d0*D*DDH)
-         DIDHH=(-pow2((2.0d0*EDH-D*DDH)/DISCR)+2.0d0*EDHH-DDH*DDH-D*DDHH)/DISCR
-         S1=-C/E*GAME
-         S1H=CDH/C-EDH/E
-         S1DH=S1*S1H
-         S1DHH=S1DH*S1H+S1*(CDHH/C-pow2(CDH/C)-EDHH/E+pow2(EDH/E))
-         S1DG=-C/E ! => S1DGG=0
-         S1DHG=S1DG*(CDH/C-EDH/E)
-         B2=B-C*D/E
-         B2DH=BDH-(CDH*D+C*DDH)/E+C*D*EDH/(E*E)
-         B2DHH=BDHH-(CDHH*D+2d0*CDH*DDH+C*DDHH)/E+(2d0*(CDH*D+C*DDH-C*D*EDH/E)*EDH+C*D*EDHH)/(E*E)
-         SQGE=SQRT(GAME)
-         S2=-2.d0/E*B2*SQGE
-         S2H=B2DH/B2-EDH/E
-         S2DH=S2*S2H
-         S2DHH=S2DH*S2H+S2*(B2DHH/B2-pow2(B2DH/B2)-EDHH/E+pow2(EDH/E))
-         S2DG=0.5d0*S2/GAME
-         S2DGG=-0.5d0*S2DG/GAME
-         S2DHG=0.5d0*S2DH/GAME
-         R3=E*GAME+D*SQGE+1.0d0
-         R3DH=EDH*GAME+DDH*SQGE
-         R3DHH=EDHH*GAME+DDHH*SQGE
-         R3DG=E+0.5d0*D/SQGE
-         R3DGG=-0.25d0*D/(GAME*SQGE)
-         R3DHG=EDH+0.5d0*DDH/SQGE
-         B3=A-C/E
-         B3DH=ADH-CDH/E+C*EDH/(E*E)
-         B3DHH=ADHH-CDHH/E+(2.0d0*CDH*EDH+C*EDHH)/(E*E)-2d0*C*EDH*EDH/pow3(E)
-         C3=(D/E*B2-B3)/E
-         C3DH=(DDH*B2+D*B2DH+B3*EDH)/(E*E)-2d0*D*B2*EDH/pow3(E)-B3DH/E
-         C3DHH=(-B3DHH &
-            + (DDHH*B2+2d0*DDH*B2DH+D*B2DHH+B3DH*EDH+B3*EDHH+B3DH*EDH)/E &
-            - 2.0d0*((DDH*B2+D*B2DH+B3*EDH+DDH*B2+D*B2DH)*EDH+D*B2*EDHH)/(E*E) &
-            + 6.0d0*D*B2*EDH*EDH/pow3(E))/E
-         S3=C3*log(R3)
-         S3DH=S3*C3DH/C3+C3*R3DH/R3
-         S3DHH=(S3DH*C3DH+S3*C3DHH)/C3-S3*pow2(C3DH/C3) &
-            + (C3DH*R3DH+C3*R3DHH)/R3-C3*pow2(R3DH/R3)
-         S3DG=C3*R3DG/R3
-         S3DGG=C3*(R3DGG/R3-pow2(R3DG/R3))
-         S3DHG=(C3DH*R3DG+C3*R3DHG)/R3-C3*R3DG*R3DH/(R3*R3)
-         B4=2.d0-D*D/E
-         B4DH=EDH*(D/E)*(D/E)-2d0*D*DDH/E
-         B4DHH=EDHH*(D/E)*(D/E)+2d0*EDH*(D/E)*(D/E)*(DDH/D-EDH/E) &
-            - 2d0*(DDH*DDH+D*DDHH)/E+2d0*D*DDH*EDH/(E*E)
-         C4=2d0*E*SQGE+D
-         C4DH=2d0*EDH*SQGE+DDH
-         C4DHH=2d0*EDHH*SQGE+DDHH
-         C4DG=E/SQGE
-         C4DGG=-0.5d0*E/(GAME*SQGE)
-         C4DHG=EDH/SQGE
-         S4A=2.0d0/E/DISCR
-         S4AH=EDH/E+DIDH/DISCR
-         S4ADH=-S4A*S4AH
-         S4ADHH=-S4ADH*S4AH - S4A*(EDHH/E-(EDH/E)*(EDH/E)+DIDHH/DISCR-pow2(DIDH/DISCR))
-         S4B=D*B3+B4*B2
-         S4BDH=DDH*B3+D*B3DH+B4DH*B2+B4*B2DH
-         S4BDHH=DDHH*B3+2d0*DDH*B3DH+D*B3DHH+B4DHH*B2+2d0*B4DH*B2DH+B4*B2DHH
-         S4C=atan(C4/DISCR)-atan(D/DISCR)
-         UP1=C4DH*DISCR-C4*DIDH
-         DN1=DISCR*DISCR+C4*C4
-         UP2=DDH*DISCR-D*DIDH
-         DN2=DISCR*DISCR+D*D
-         S4CDH=UP1/DN1-UP2/DN2
-         S4CDHH=(C4DHH*DISCR-C4*DIDHH)/DN1 &
-            - UP1*2d0*(DISCR*DIDH+C4*C4DH)/(DN1*DN1) &
-            - (DDHH*DISCR-D*DIDHH)/DN2+UP2*2d0*(DISCR*DIDH+D*DDH)/(DN2*DN2)
-         S4CDG=C4DG*DISCR/DN1
-         S4CDGG=C4DGG*DISCR/DN1-2d0*C4*DISCR*pow2(C4DG/DN1)
-         S4CDHG=(C4DHG*DISCR+C4DG*DIDH-C4DG*DISCR/DN1*2d0*(DISCR*DIDH+C4*C4DH))/DN1
-         S4=S4A*S4B*S4C
-         S4DH=S4ADH*S4B*S4C+S4A*S4BDH*S4C+S4A*S4B*S4CDH
-         S4DHH=S4ADHH*S4B*S4C+S4A*S4BDHH*S4C+S4A*S4B*S4CDHH &
-            + 2d0*(S4ADH*S4BDH*S4C+S4ADH*S4B*S4CDH+S4A*S4BDH*S4CDH)
-         S4DG=S4A*S4B*S4CDG
-         S4DGG=S4A*S4B*S4CDGG
-         S4DHG=S4A*S4B*S4CDHG+S4CDG*(S4ADH*S4B+S4A*S4BDH)
-         FXC=S1+S2+S3+S4
-         FXCDH=S1DH+S2DH+S3DH+S4DH
-         FXCDG=S1DG+S2DG+S3DG+S4DG
-         FXCDHH=S1DHH+S2DHH+S3DHH+S4DHH
-         FXCDGG=S2DGG+S3DGG+S4DGG
-         FXCDHG=S1DHG+S2DHG+S3DHG+S4DHG
-         PXC=(GAME*FXCDG-2d0*THETA*FXCDH)/3.d0
-         UXC=GAME*FXCDG-THETA*FXCDH
-         SXC=(GAME*S2DG-S2+GAME*S3DG-S3+S4A*S4B*(GAME*S4CDG-S4C))-THETA*FXCDH
-         if (abs(SXC).lt.1.d-9*abs(THETA*FXCDH)) SXC=0.d0 ! accuracy loss
-         CVXC=2d0*THETA*(GAME*FXCDHG-FXCDH)-THETA*THETA*FXCDHH-GAME*GAME*FXCDGG
-         if (abs(CVXC).lt.1.d-9*abs(GAME*GAME*FXCDGG)) CVXC=0.d0 ! accuracy
-         PDLH=THETA*(GAME*FXCDHG-2d0*FXCDH-2d0*THETA*FXCDHH)/3.d0
-         PDLG=GAME*(FXCDG+GAME*FXCDGG-2d0*THETA*FXCDHG)/3.d0
-         PDRXC=PXC+(PDLG-2d0*PDLH)/3.d0
-         PDTXC=GAME*(THETA*FXCDHG-GAME*FXCDGG/3.d0)-THETA*(FXCDH/0.75d0+THETA*FXCDHH/1.5d0)
-
-      endif
-
-
-      if (debug_EXCOR7_table .and. .not. skip) then
-
-         if (.not. check1(FXC, xFXC, 'FXC')) return
-         if (.not. check1(UXC, xUXC, 'UXC')) return
-         if (.not. check1(PXC, xPXC, 'PXC')) return
-         if (.not. check1(CVXC, xCVXC, 'CVXC')) return
-         if (.not. check1(SXC, xSXC, 'SXC')) return
-         if (.not. check1(PDTXC, xPDTXC, 'PDTXC')) return
-         if (.not. check1(PDRXC, xPDRXC, 'PDRXC')) return
-
+      THETA=0.543d0*RS/GAME ! non-relativistic degeneracy parameter
+      SQTH=dsqrt(THETA)
+      THETA2=THETA*THETA
+      THETA3=THETA2*THETA
+      THETA4=THETA3*THETA
+      if (THETA.gt..005d0) then
+         CHT1=cosh(1.d0/THETA)
+         SHT1=sinh(1.d0/THETA)
+         CHT2=cosh(1.d0/SQTH)
+         SHT2=sinh(1.d0/SQTH)
+         T1=SHT1/CHT1 ! dtanh(1.d0/THETA)
+         T2=SHT2/CHT2 ! dtanh(1./dsqrt(THETA))
+         T1DH=-1./((THETA*CHT1)*(THETA*CHT1)) ! d T1 / d\theta
+         T1DHH=2./pow3(THETA*CHT1)*(CHT1-SHT1/THETA)
+         T2DH=-0.5d0*SQTH/((THETA*CHT2)*(THETA*CHT2))
+         T2DHH=(0.75d0*SQTH*CHT2-0.5d0*SHT2)/pow3(THETA*CHT2)
+      else
+         T1=1.
+         T2=1.
+         T1DH=0.
+         T2DH=0.
+         T1DHH=0.
+         T2DHH=0.
       endif
-
-      if (use_EXCOR7_table .and. .not. skip) then
-
-         ! values
-         FXC = xFXC
-         UXC = xUXC
-         PXC = xPXC
-         CVXC = xCVXC
-         SXC = xSXC
-         PDTXC = xPDTXC
-         PDRXC = xPDRXC
-
-         ! dT (val1) derivatives
-         ! numerically, RS% d1val1 / RS% val is not quite 0
-         dlnRs_dT = RS% d1val1 / RS% val
-         dlnGAME_dT = GAME% d1val1 / GAME% val
-
-         FXC% d1val1 = dFXC_dlnRS * dlnRS_dT + dFXC_dlnGAME * dlnGAME_dT
-         UXC% d1val1 = dUXC_dlnRS * dlnRS_dT + dUXC_dlnGAME * dlnGAME_dT
-         PXC% d1val1 = dPXC_dlnRS * dlnRS_dT + dPXC_dlnGAME * dlnGAME_dT
-         CVXC% d1val1 = dCVXC_dlnRS * dlnRS_dT + dCVXC_dlnGAME * dlnGAME_dT
-         SXC% d1val1 = dSXC_dlnRS * dlnRS_dT + dSXC_dlnGAME * dlnGAME_dT
-         PDTXC% d1val1 = dPDTXC_dlnRS * dlnRS_dT + dPDTXC_dlnGAME * dlnGAME_dT
-         PDRXC% d1val1 = dPDRXC_dlnRS * dlnRS_dT + dPDRXC_dlnGAME * dlnGAME_dT
-
-         ! dRho (val2) derivatives
-         dlnRs_dRho = RS% d1val2 / RS% val
-         dlnGAME_dRho = GAME% d1val2 / GAME% val
-
-         FXC% d1val2 = dFXC_dlnRS * dlnRS_dRho + dFXC_dlnGAME * dlnGAME_dRho
-         UXC% d1val2 = dUXC_dlnRS * dlnRS_dRho + dUXC_dlnGAME * dlnGAME_dRho
-         PXC% d1val2 = dPXC_dlnRS * dlnRS_dRho + dPXC_dlnGAME * dlnGAME_dRho
-         CVXC% d1val2 = dCVXC_dlnRS * dlnRS_dRho + dCVXC_dlnGAME * dlnGAME_dRho
-         SXC% d1val2 = dSXC_dlnRS * dlnRS_dRho + dSXC_dlnGAME * dlnGAME_dRho
-         PDTXC% d1val2 = dPDTXC_dlnRS * dlnRS_dRho + dPDTXC_dlnGAME * dlnGAME_dRho
-         PDRXC% d1val2 = dPDRXC_dlnRS * dlnRS_dRho + dPDRXC_dlnGAME * dlnGAME_dRho
-
-      end if
-      
-      contains
-      
-      logical function check1(v, xv, str)
-         type(auto_diff_real_2var_order1), intent(in) :: v
-         real(dp), intent(in) :: xv
-         character (len=*), intent(in) :: str
-         real(dp) :: val
-         real(dp), parameter :: atol = 1d-8, rtol = 1d-6
-         include 'formats'
-         val = v%val
-         check1 = .false.
-         if (is_bad(xv)) then
-            write(*,*) 'is_bad ' // trim(str), xv, val, RS, GAME
-            return
-         end if
-         if (abs(val - xv) > atol + rtol*max(abs(val),abs(xv))) then
-            write(*,*) 'rel mismatch ' // trim(str), &
-               (val - xv)/max(abs(val),abs(xv),1d-99), &
-               xv, val, RS%val, GAME%val
-            stop 'EXCOR7'
-            return
-         end if
-         check1 = .true.
-      end function check1
-
-
+      A0=0.75d0+3.04363d0*THETA2-0.09227d0*THETA3+1.7035d0*THETA4
+      A0DH=6.08726d0*THETA-0.27681d0*THETA2+6.814d0*THETA3
+      A0DHH=6.08726d0-0.55362d0*THETA+20.442d0*THETA2
+      A1=1.+8.31051d0*THETA2+5.1105d0*THETA4
+      A1DH=16.62102d0*THETA+20.442d0*THETA3
+      A1DHH=16.62102d0+61.326d0*THETA2
+      A=0.610887d0*A0/A1*T1 ! HF fit of Perrot and Dharma-wardana
+      AH=A0DH/A0-A1DH/A1+T1DH/T1
+      ADH=A*AH
+      ADHH=ADH*AH+A*(A0DHH/A0-pow2(A0DH/A0)-A1DHH/A1+pow2(A1DH/A1) &
+         + T1DHH/T1-pow2(T1DH/T1))
+      B0=0.341308d0+12.070873d0*THETA2+1.148889d0*THETA4
+      B0DH=24.141746d0*THETA+4.595556d0*THETA3
+      B0DHH=24.141746d0+13.786668d0*THETA2
+      B1=1.+10.495346d0*THETA2+1.326623d0*THETA4
+      B1DH=20.990692d0*THETA+5.306492d0*THETA3
+      B1DHH=20.990692d0+15.919476d0*THETA2
+      B=SQTH*T2*B0/B1
+      BH=0.5d0/THETA+T2DH/T2+B0DH/B0-B1DH/B1
+      BDH=B*BH
+      BDHH=BDH*BH+B*(-0.5d0/THETA2+T2DHH/T2-pow2(T2DH/T2) &
+         + B0DHH/B0-pow2(B0DH/B0)-B1DHH/B1+pow2(B1DH/B1))
+      D0=0.614925d0+16.996055d0*THETA2+1.489056d0*THETA4
+      D0DH=33.99211d0*THETA+5.956224d0*THETA3
+      D0DHH=33.99211d0+17.868672d0*THETA2
+      D1=1.+10.10935d0*THETA2+1.22184d0*THETA4
+      D1DH=20.2187d0*THETA+4.88736d0*THETA3
+      D1DHH=20.2187d0+14.66208d0*THETA2
+      D=SQTH*T2*D0/D1
+      DH=0.5d0/THETA+T2DH/T2+D0DH/D0-D1DH/D1
+      DDH=D*DH
+      DDHH=DDH*DH+D*(-0.5d0/THETA2+T2DHH/T2-pow2(T2DH/T2) &
+         + D0DHH/D0-pow2(D0DH/D0)-D1DHH/D1+pow2(D1DH/D1))
+      E0=0.539409d0+2.522206d0*THETA2+0.178484d0*THETA4
+      E0DH=5.044412d0*THETA+0.713936d0*THETA3
+      E0DHH=5.044412d0+2.141808d0*THETA2
+      E1=1.+2.555501d0*THETA2+0.146319d0*THETA4
+      E1DH=5.111002d0*THETA+0.585276d0*THETA3
+      E1DHH=5.111002d0+1.755828d0*THETA2
+      E=THETA*T1*E0/E1
+      EH=1./THETA+T1DH/T1+E0DH/E0-E1DH/E1
+      EDH=E*EH
+      EDHH=EDH*EH+E*(T1DHH/T1-pow2(T1DH/T1)+E0DHH/E0-pow2(E0DH/E0) &
+         - E1DHH/E1+pow2(E1DH/E1)-1.0d0/THETA2)
+      EXP1TH=exp(-1.d0/THETA)
+      C=(0.872496d0+0.025248d0*EXP1TH)*E
+      CDH=0.025248d0*EXP1TH/THETA2*E+C*EDH/E
+      CDHH=0.025248d0*EXP1TH/THETA2*(EDH+(1.0d0-2.0d0*THETA)/THETA2*E) &
+         + CDH*EDH/E+C*EDHH/E-C*pow2(EDH/E)
+      DISCR=SQRT(4.0d0*E-D*D)
+      DIDH=0.5d0/DISCR*(4.0d0*EDH-2.0d0*D*DDH)
+      DIDHH=(-pow2((2.0d0*EDH-D*DDH)/DISCR)+2.0d0*EDHH-DDH*DDH-D*DDHH)/DISCR
+      S1=-C/E*GAME
+      S1H=CDH/C-EDH/E
+      S1DH=S1*S1H
+      S1DHH=S1DH*S1H+S1*(CDHH/C-pow2(CDH/C)-EDHH/E+pow2(EDH/E))
+      S1DG=-C/E ! => S1DGG=0
+      S1DHG=S1DG*(CDH/C-EDH/E)
+      B2=B-C*D/E
+      B2DH=BDH-(CDH*D+C*DDH)/E+C*D*EDH/(E*E)
+      B2DHH=BDHH-(CDHH*D+2.*CDH*DDH+C*DDHH)/E+(2.*(CDH*D+C*DDH-C*D*EDH/E)*EDH+C*D*EDHH)/(E*E)
+      SQGE=SQRT(GAME)
+      S2=-2.d0/E*B2*SQGE
+      S2H=B2DH/B2-EDH/E
+      S2DH=S2*S2H
+      S2DHH=S2DH*S2H+S2*(B2DHH/B2-pow2(B2DH/B2)-EDHH/E+pow2(EDH/E))
+      S2DG=0.5d0*S2/GAME
+      S2DGG=-0.5d0*S2DG/GAME
+      S2DHG=0.5d0*S2DH/GAME
+      R3=E*GAME+D*SQGE+1.0d0
+      R3DH=EDH*GAME+DDH*SQGE
+      R3DHH=EDHH*GAME+DDHH*SQGE
+      R3DG=E+0.5d0*D/SQGE
+      R3DGG=-0.25d0*D/(GAME*SQGE)
+      R3DHG=EDH+0.5d0*DDH/SQGE
+      B3=A-C/E
+      B3DH=ADH-CDH/E+C*EDH/(E*E)
+      B3DHH=ADHH-CDHH/E+(2.0d0*CDH*EDH+C*EDHH)/(E*E)-2.*C*EDH*EDH/pow3(E)
+      C3=(D/E*B2-B3)/E
+      C3DH=(DDH*B2+D*B2DH+B3*EDH)/(E*E)-2.*D*B2*EDH/pow3(E)-B3DH/E
+      C3DHH=(-B3DHH &
+         + (DDHH*B2+2.*DDH*B2DH+D*B2DHH+B3DH*EDH+B3*EDHH+B3DH*EDH)/E &
+         - 2.0d0*((DDH*B2+D*B2DH+B3*EDH+DDH*B2+D*B2DH)*EDH+D*B2*EDHH)/(E*E) &
+         + 6.0d0*D*B2*EDH*EDH/pow3(E))/E
+      S3=C3*log(R3)
+      S3DH=S3*C3DH/C3+C3*R3DH/R3
+      S3DHH=(S3DH*C3DH+S3*C3DHH)/C3-S3*pow2(C3DH/C3) &
+         + (C3DH*R3DH+C3*R3DHH)/R3-C3*pow2(R3DH/R3)
+      S3DG=C3*R3DG/R3
+      S3DGG=C3*(R3DGG/R3-pow2(R3DG/R3))
+      S3DHG=(C3DH*R3DG+C3*R3DHG)/R3-C3*R3DG*R3DH/(R3*R3)
+      B4=2.-D*D/E
+      B4DH=EDH*(D/E)*(D/E)-2.*D*DDH/E
+      B4DHH=EDHH*(D/E)*(D/E)+2.*EDH*(D/E)*(D/E)*(DDH/D-EDH/E) &
+         - 2.*(DDH*DDH+D*DDHH)/E+2.*D*DDH*EDH/(E*E)
+      C4=2.*E*SQGE+D
+      C4DH=2.*EDH*SQGE+DDH
+      C4DHH=2.*EDHH*SQGE+DDHH
+      C4DG=E/SQGE
+      C4DGG=-0.5d0*E/(GAME*SQGE)
+      C4DHG=EDH/SQGE
+      S4A=2.0d0/E/DISCR
+      S4AH=EDH/E+DIDH/DISCR
+      S4ADH=-S4A*S4AH
+      S4ADHH=-S4ADH*S4AH - S4A*(EDHH/E-(EDH/E)*(EDH/E)+DIDHH/DISCR-pow2(DIDH/DISCR))
+      S4B=D*B3+B4*B2
+      S4BDH=DDH*B3+D*B3DH+B4DH*B2+B4*B2DH
+      S4BDHH=DDHH*B3+2.*DDH*B3DH+D*B3DHH+B4DHH*B2+2.*B4DH*B2DH+B4*B2DHH
+      S4C=atan(C4/DISCR)-atan(D/DISCR)
+      UP1=C4DH*DISCR-C4*DIDH
+      DN1=DISCR*DISCR+C4*C4
+      UP2=DDH*DISCR-D*DIDH
+      DN2=DISCR*DISCR+D*D
+      S4CDH=UP1/DN1-UP2/DN2
+      S4CDHH=(C4DHH*DISCR-C4*DIDHH)/DN1 &
+         - UP1*2.*(DISCR*DIDH+C4*C4DH)/(DN1*DN1) &
+         - (DDHH*DISCR-D*DIDHH)/DN2+UP2*2.*(DISCR*DIDH+D*DDH)/(DN2*DN2)
+      S4CDG=C4DG*DISCR/DN1
+      S4CDGG=C4DGG*DISCR/DN1-2.*C4*DISCR*pow2(C4DG/DN1)
+      S4CDHG=(C4DHG*DISCR+C4DG*DIDH-C4DG*DISCR/DN1*2.*(DISCR*DIDH+C4*C4DH))/DN1
+      S4=S4A*S4B*S4C
+      S4DH=S4ADH*S4B*S4C+S4A*S4BDH*S4C+S4A*S4B*S4CDH
+      S4DHH=S4ADHH*S4B*S4C+S4A*S4BDHH*S4C+S4A*S4B*S4CDHH &
+         + 2.*(S4ADH*S4BDH*S4C+S4ADH*S4B*S4CDH+S4A*S4BDH*S4CDH)
+      S4DG=S4A*S4B*S4CDG
+      S4DGG=S4A*S4B*S4CDGG
+      S4DHG=S4A*S4B*S4CDHG+S4CDG*(S4ADH*S4B+S4A*S4BDH)
+      FXC=S1+S2+S3+S4
+      FXCDH=S1DH+S2DH+S3DH+S4DH
+      FXCDG=S1DG+S2DG+S3DG+S4DG
+      FXCDHH=S1DHH+S2DHH+S3DHH+S4DHH
+      FXCDGG=S2DGG+S3DGG+S4DGG
+      FXCDHG=S1DHG+S2DHG+S3DHG+S4DHG
+      PXC=(GAME*FXCDG-2.*THETA*FXCDH)/3.
+      UXC=GAME*FXCDG-THETA*FXCDH
+      SXC=(GAME*S2DG-S2+GAME*S3DG-S3+S4A*S4B*(GAME*S4CDG-S4C))-THETA*FXCDH
+      if (dabs(SXC).lt.1.d-9*dabs(THETA*FXCDH)) SXC=0. ! accuracy loss
+      CVXC=2.*THETA*(GAME*FXCDHG-FXCDH)-THETA*THETA*FXCDHH-GAME*GAME*FXCDGG
+      if (dabs(CVXC).lt.1.d-9*dabs(GAME*GAME*FXCDGG)) CVXC=0. ! accuracy
+      PDLH=THETA*(GAME*FXCDHG-2.*FXCDH-2.*THETA*FXCDHH)/3.
+      PDLG=GAME*(FXCDG+GAME*FXCDGG-2.*THETA*FXCDHG)/3.
+      PDRXC=PXC+(PDLG-2.*PDLH)/3.
+      PDTXC=GAME*(THETA*FXCDHG-GAME*FXCDGG/3.)-THETA*(FXCDH/0.75d0+THETA*FXCDHH/1.5d0)
+      return
       end subroutine EXCOR7
 
 ! ======================  AUXILIARY SUBROUTINES   ==================== *
@@ -2151,24 +1553,24 @@
 ! jump at f=4:
 !         for XDF: 6.e-7, 5.4e-7, 9.6e-8, 3.1e-7
 !       for XDFF: 4.7e-5, 4.8e-5, 2.3e-6, 1.5e-6
-      type(auto_diff_real_2var_order1) :: F ! can be modified, not sure if this is an intended side-effect
+      real(dp) :: F ! can be modified, not sure if this is an intended side-effect
       integer, intent(in) :: N
-      type(auto_diff_real_2var_order1), intent(out) :: X, XDF, XDFF
+      real(dp), intent(out) :: X, XDF, XDFF
+      !save
       integer :: I
-      type(auto_diff_real_2var_order1) :: P, T, T1, T2, UP, UP1, UP2, DOWN, DOWN1, DOWN2
-      type(auto_diff_real_2var_order1) :: R, R1, R2, RT
+      real(dp) :: P, T, T1, T2, UP, UP1, UP2, DOWN, DOWN1, DOWN2
+      real(dp) :: R, R1, R2, RT
       
-      ! The next four are really parameters but there isn't a clean way to initialize them
-      ! at declaration time. - Adam Jermyn 4/2/2020
-      real(dp) :: A(0:5,0:3) ! read only after initialization
-      real(dp) :: B(0:6,0:3) ! read only after initialization
-      real(dp) :: C(0:6,0:3) ! read only after initialization
-      real(dp) :: D(0:6,0:3) ! read only after initialization
-
+      logical, save :: initialized = .false.
+      real(dp), save :: A(0:5,0:3) ! read only after initialization
+      real(dp), save :: B(0:6,0:3) ! read only after initialization
+      real(dp), save :: C(0:6,0:3) ! read only after initialization
+      real(dp), save :: D(0:6,0:3) ! read only after initialization
       integer, parameter :: LA(0:3) = (/5,4,3,2/)
       integer, parameter :: LB(0:3) = (/6,3,4,3/)
       integer, parameter :: LD(0:3) = (/6,5,5,6/)
 
+      if (.not. initialized) then
          A(0:5,0) = (/ &
             -1.570044577033d4,1.001958278442d4,-2.805343454951d3, &
                   4.121170498099d2,-3.174780572961d1,1.d0/) ! X_{-1/2}
@@ -2225,17 +1627,18 @@
           -2.315515517515d-2,9.198776585252d-2,-3.835879295548d-1, &
              5.415026856351d-1,-3.847241692193d-1,3.739781456585d-2, &
              -3.008504449098d-2/) ! X_{5/2}
+      end if
       
-      if (N.lt.0d0 .or.N.gt.3d0) stop 'FERINV7: Invalid subscript'
-      if (F.le.0.d0) F = 1d-99 !stop 'FERINV7: Non-positive argument'
-      if (F.lt.4.d0) then
+      if (N.lt.0.or.N.gt.3) stop 'FERINV7: Invalid subscript'
+      if (F.le.0.) F = 1d-99 !stop 'FERINV7: Non-positive argument'
+      if (F.lt.4.) then
          T=F
-         UP=0.d0
-         UP1=0.d0
-         UP2=0.d0
-         DOWN=0.d0
-         DOWN1=0.d0
-         DOWN2=0.d0
+         UP=0.
+         UP1=0.
+         UP2=0.
+         DOWN=0.
+         DOWN1=0.
+         DOWN2=0.
          do I=LA(N),0,-1
             UP=UP*T+A(I,N)
            if (I.ge.1) UP1=UP1*T+A(I,N)*I
@@ -2250,7 +1653,7 @@
          XDF=1.d0/T+UP1/UP-DOWN1/DOWN
          XDFF=-1.d0/(T*T)+UP2/UP-pow2(UP1/UP)-DOWN2/DOWN+pow2(DOWN1/DOWN)
       else
-         P=-1.d0/(.5d0+N) ! = -1/(1+\nu) = power index
+         P=-1./(.5+N) ! = -1/(1+\nu) = power index
          T=pow(F,P) ! t - argument of the rational fraction
          T1=P*T/F ! dt/df
          T2=P*(P-1.d0)*T/(F*F) ! d^2 t / df^2
@@ -2272,11 +1675,11 @@
          enddo
          R=UP/DOWN
          R1=(UP1-UP*DOWN1/DOWN)/DOWN ! dR/dt
-         R2=(UP2-(2.0d0*UP1*DOWN1+UP*DOWN2)/DOWN+2.d0*UP*pow2(DOWN1/DOWN))/DOWN
+         R2=(UP2-(2.0d0*UP1*DOWN1+UP*DOWN2)/DOWN+2.*UP*pow2(DOWN1/DOWN))/DOWN
          X=R/T
          RT=(R1-R/T)/T
          XDF=T1*RT
-         XDFF=T2*RT+T1*T1*(R2-2d0*RT)/T
+         XDFF=T2*RT+T1*T1*(R2-2.*RT)/T
       endif
       return
       end subroutine FERINV7
@@ -2295,37 +1698,29 @@
 !         WkDTT=d^2 Wk / d T^2, WkDXT=d^2 Wk /dCHIdT,
 !         W0XXX=d^3 W0 / d CHI^3, W0XTT=d^3 W0 /(d CHI d^2 T),
 !         W0XXT=d^3 W0 /dCHI^2 dT
-      type(auto_diff_real_2var_order1), intent(in) :: TEMP,CHI
-      type(auto_diff_real_2var_order1), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W0XXX,W0XTT,W0XXT
-
-      type(auto_diff_real_2var_order1) :: X1, X2, FP, FM
-      type(auto_diff_real_2var_order1) :: W0a,W0DXa,W0DTa,W0DXXa,W0DTTa,W0DXTa
-      type(auto_diff_real_2var_order1) :: W1a,W1DXa,W1DTa,W1DXXa,W1DTTa,W1DXTa
-      type(auto_diff_real_2var_order1) :: W2a,W2DXa,W2DTa,W2DXXa,W2DTTa,W2DXTa
-      type(auto_diff_real_2var_order1) :: W0XXXa,W0XTTa,W0XXTa
-      type(auto_diff_real_2var_order1) :: W0b,W0DXb,W0DTb,W0DXXb,W0DTTb,W0DXTb
-      type(auto_diff_real_2var_order1) :: W1b,W1DXb,W1DTb,W1DXXb,W1DTTb,W1DXTb
-      type(auto_diff_real_2var_order1) :: W2b,W2DXb,W2DTb,W2DXXb,W2DTTb,W2DXTb
-      type(auto_diff_real_2var_order1) :: W0XXXb,W0XTTb,W0XXTb
+      real(dp), intent(in) :: TEMP,CHI
+      real(dp), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
+      real(dp), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
+      real(dp), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
+      real(dp), intent(out) :: W0XXX,W0XTT,W0XXT
+
+      real(dp) :: X1, X2, FP, FM
+      real(dp) :: W0a,W0DXa,W0DTa,W0DXXa,W0DTTa,W0DXTa
+      real(dp) :: W1a,W1DXa,W1DTa,W1DXXa,W1DTTa,W1DXTa
+      real(dp) :: W2a,W2DXa,W2DTa,W2DXXa,W2DTTa,W2DXTa
+      real(dp) :: W0XXXa,W0XTTa,W0XXTa
+      real(dp) :: W0b,W0DXb,W0DTb,W0DXXb,W0DTTb,W0DXTb
+      real(dp) :: W1b,W1DXb,W1DTb,W1DXXb,W1DTTb,W1DXTb
+      real(dp) :: W2b,W2DXb,W2DTb,W2DXXb,W2DTTb,W2DXTb
+      real(dp) :: W0XXXb,W0XTTb,W0XXTb
       
-      type(auto_diff_real_2var_order1) :: CHI1
-      type(auto_diff_real_2var_order1) :: CHI2
-      type(auto_diff_real_2var_order1) :: XMAX
-      type(auto_diff_real_2var_order1) :: DCHI1
-      type(auto_diff_real_2var_order1) :: DCHI2
-      type(auto_diff_real_2var_order1) :: XSCAL1
-      type(auto_diff_real_2var_order1) :: XSCAL2
-
-      CHI1=0.6d0
-      CHI2=14.d0
-      XMAX=30.d0
-      DCHI1=0.1d0
-      DCHI2=CHI2-CHI1-DCHI1
-      XSCAL1=XMAX/DCHI1
-      XSCAL2=XMAX/DCHI2
+      real(dp), parameter :: CHI1=0.6d0
+      real(dp), parameter :: CHI2=14.d0
+      real(dp), parameter :: XMAX=30.d0
+      real(dp), parameter :: DCHI1=0.1d0
+      real(dp), parameter :: DCHI2=CHI2-CHI1-DCHI1
+      real(dp), parameter :: XSCAL1=XMAX/DCHI1
+      real(dp), parameter :: XSCAL2=XMAX/DCHI2
       
       X1=(CHI-CHI1)*XSCAL1
       X2=(CHI-CHI2)*XSCAL2
@@ -2337,7 +1732,7 @@
            W0XXX,W0XTT,W0XXT)
       elseif (X2.lt.XMAX) then ! match two fits
         if (X1.lt.XMAX) then ! match fits "a" and "b"
-           call FERMI10(X1,XMAX,FP,FM)
+           call FERMI(X1,XMAX,FP,FM)
            call BLIN9a(TEMP,CHI, &
              W0a,W0DXa,W0DTa,W0DXXa,W0DTTa,W0DXTa, &
              W1a,W1DXa,W1DTa,W1DXXa,W1DTTa,W1DXTa, &
@@ -2349,7 +1744,7 @@
              W2b,W2DXb,W2DTb,W2DXXb,W2DTTb,W2DXTb, &
              W0XXXb,W0XTTb,W0XXTb)
         else ! match fits "b" and "c"
-           call FERMI10(X2,XMAX,FP,FM)
+           call FERMI(X2,XMAX,FP,FM)
            call BLIN9b(TEMP,CHI, &
              W0a,W0DXa,W0DTa,W0DXXa,W0DTTa,W0DXTa, &
              W1a,W1DXa,W1DTa,W1DXXa,W1DTTa,W1DXTa, &
